$(document).ready(function () {
    $.ajaxSetup({
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        }
    });
    $('#imagemodal').on('show.bs.modal', function (e) {
        // $(".imagepreview").attr("src",$(this).attr('src'));

        var source = $(e.relatedTarget).data('source');
        $(".imagepreview").attr("src", source);

    });
    view_table();

    $("#btn_guardar").click(function () {

        var data = new $('#form_consultas').serialize();

        $.ajax({
            type: 'POST',
            url: '/save_consulta',
            data: data,
            beforeSend: function () {
                $('#div_mensajes').removeClass('d-none');
                $('#div_mensajes').addClass('text-center');
                $('#mensajes').html('<img src="../storage/images/load.gif" width="5%" height="5%" />');
            },
            success: function (data) {
                var d = JSON.parse(data);
                $('#div_mensajes').removeClass('d-none text-center')
                if (d['msg'] == 'error') {
                    toastr.error(d['data']);
                } else {
                    toastr.success(d['data']);
                    view_table();
                    $('#btn_modalevol').show();
                    $('#evolucion').show();
                    $('#txt_id').val(d['consulta_id']);
                    $('#txt_idconsulta').val(d['consulta_id']);
                    $('#hide_idconsulta').val(d['consulta_id']);
                    view_tableconsultas(d['consulta_id']);
                    //clear_data();
                }
            },
            error: function (xhr) { // if error occured
                toastr.error('Error: '.xhr.statusText + xhr.responseText);
            },
            complete: function () {
                $('#div_mensajes').addClass('d-none');
            },
            dataType: 'html'
        });
    });


    function view_table() {
        var data = $('#form_paciente').serialize();
        var pageURL = window.location.href;
        var lastURLSegment = pageURL.substr(pageURL.lastIndexOf('/') + 1);
        console.log('en el view_table');
        console.log(data);
        $.ajax({
            type: 'POST',
            url: '/view_data_consulta/' + lastURLSegment,
            data: data,
            beforeSend: function () {
                $('#div_mensajes').removeClass('d-none');
                $('#div_mensajes').addClass('text-center');
                $('#mensajes').html('<img src="../storage/images/load.gif" width="5%" height="5%" />');
            },
            success: function (data) {
                console.log('datos de la consulta');
                console.log(data);
                $('#div_table').html(data);
                $('#tbl_consulta').DataTable({
                    "paging": true,
                    "lengthChange": false,
                    "ordering": true,
                    "info": true,
                    "autoWidth": false,
                    "responsive": true,
                    "drawCallback": acciones,
                });
                acciones();

            },
            error: function (xhr) { // if error occured
                toastr.error('Error: '.xhr.statusText + xhr.responseText);
            },
            complete: function () {
                $('#div_mensajes').addClass('d-none');
            },
            dataType: 'html'
        });
    }

    function clear_data() {
        $('#txt_motivo').val('');
        $('#txt_id').val('');
        $('#fechaconsulta').val('');
        $('#txt_medico').val('');
        $('#txt_medico').attr('data-id', '');
        $('#txt_diagnostico').val('');
        $('#txt_objetivo').val('');
        $('#txt_plan').val('');
        $('#txt_idconsulta').val('');
        $('#fechaconsulta').text('');
        $('#txt_id').val('');
        // acciones();
    }

    function clear_evaluacion() {
        $('#txt_fecha').val('');
        $('#txt_descripcioneval').val('');
        $('#imagenEvaluacion').attr('src', '../storage/images/Evaluation_Person.png');
        $('#evaluacionimage').val('');
    }

    function acciones() {

        $(".btn_edit").unbind().click(function () {
            var data = $(this).data('id');
            $.ajax({
                type: 'POST',
                url: '/edit_consulta',
                data: {
                    "_token": $('meta[name="csrf-token"]').attr('content'),
                    "id": data
                },
                beforeSend: function () {
                    $('#div_mensajes').removeClass('d-none');
                    $('#div_mensajes').addClass('text-center');
                    $('#mensajes').html('<img src="../storage/images/load.gif" width="5%" height="5%" />');
                },
                success: function (d) {
                    console.log('en la funcion acciones');
                    console.log(d);
                    if (d['msg'] == 'error') {
                        toastr.error(d['data']);
                    } else {
                        toastr.success(d['info']);
                        clear_data();
                        $('#txt_idmedico').attr('data-id', d['data']['idmedico']);
                        $('#txt_idmedico').val(d['data']['idmedico'] );
                        $('#txt_medico').attr('data-id', d['data']['idmedico']);
                        $('#txt_medico').val(d['nombremedico'] );
                        $('#txt_idpaciente').val(d['data']['idpaciente']);
                        $('#txt_motivo').val(d['data']['motivo']);
                        $('#txt_diagnostico').val(d['data']['diagnostico']);
                        $('#txt_objetivo').val(d['data']['objetivo']);
                        $('#txt_plan').val(d['data']['plantratamiento']);
                        $('#txt_idconsulta').val(d['data']['id']);
                        $('#txt_id').val(d['data']['id']);
                        $('#fechaconsulta').val(d['data']['fechaconsulta']);
                        $('#hide_idpaciente').val(d['data']['idpaciente']);
                        $('#hide_idconsulta').val(d['data']['id']);

                        $('.consulta-tab').click();
                        $('#btn_modalevol').show();
                        $('#evolucion').show();

                        view_tableconsultas(data);
                    }
                },
                error: function (xhr) {
                    toastr.error('Error: '.xhr.statusText + xhr.responseText);
                },
                complete: function () {
                    $('#div_mensajes').addClass('d-none');
                    $('#div_mensajes').html(' ');
                },
            });
        });

        $(".btn_delete").unbind().click(function () {
            var data = $(this).data('id');
            $.confirm({
                title: 'Eliminar Consulta!',
                content: 'Desea realizar la eliminación de la consulta ?',
                buttons: {
                    confirm: function () {
                        $.ajax({
                            type: 'POST',
                            url: '/delete_consulta',
                            data: {
                                "_token": $('meta[name="csrf-token"]').attr('content'),
                                "id": data
                            },
                            beforeSend: function () {
                                $('#div_mensajes').removeClass('d-none');
                                $('#div_mensajes').addClass('text-center');
                                $('#mensajes').html('<img src="../storage/images/load.gif" width="5%" height="5%" />');
                            },
                            success: function (d) {
                                if (d['msg'] == 'error') {
                                    toastr.error(d['data']);
                                } else {
                                    toastr.success(d['data']);
                                    view_table();
                                    clear_data();
                                }
                            },
                            error: function (xhr) {
                                toastr.error('Error: '.xhr.statusText + xhr.responseText);
                            },
                            complete: function () {
                                $('#div_mensajes').addClass('d-none');
                            },
                        });
                    },
                    cancel: function () {
                        $.alert('Se ha cancelado la eliminación!');
                    }
                }
            });
        });


    }

    function readURL(input) {
        if (input.files && input.files[0]) {
            var reader = new FileReader();

            reader.onload = function (e) {
                $('#imagenEvaluacion').attr('src', e.target.result);
            }

            reader.readAsDataURL(input.files[0]);
        }
    }

    $("#evaluacionimage").change(function () {
        readURL(this);
    });


    function view_tableconsultas(idconsulta) {
        var data = $('#form_paciente').serialize();
        // var pageURL = window.location.href;
        //  var lastURLSegment = pageURL.substr(pageURL.lastIndexOf('/') + 1);
        $.ajax({
            type: 'POST',
            url: '/view_data_evolucion/' + idconsulta,
            data: data,
            beforeSend: function () {
                $('#div_mensajes').removeClass('d-none');
                $('#div_mensajes').addClass('text-center');
                $('#mensajes').html('<img src="../storage/images/load.gif" width="5%" height="5%" />');
            },
            success: function (data) {
                $('#div_tablaevolucion').html(data);
                $('#tbl_evolucion').DataTable({
                    "paging": true,
                    "lengthChange": false,
                    "ordering": true,
                    "info": true,
                    "autoWidth": false,
                    "responsive": true,
                    "drawCallback": accionesEvolucion,
                });
                acciones();
            },
            error: function (xhr) { // if error occured
                toastr.error('Error: '.xhr.statusText + xhr.responseText);
            },
            complete: function () {
                $('#div_mensajes').addClass('d-none');
            },
            dataType: 'html'
        });
    }


    $("#btn_guardarEvaluacion").click(function () {

        var data = new FormData($('#form_evolucion')[0]);
        var idconsulta = $('#hide_idconsulta').val();
        $.ajax({
            type: 'POST',
            enctype: 'multipart/form-data',
            cache: false,
            contentType: false,
            processData: false,
            url: '/save_evaluacion',
            data: data,
            beforeSend: function () {
                $('#div_mensajes').removeClass('d-none');
                $('#div_mensajes').addClass('text-center');
                $('#mensajes').html('<img src="../storage/images/load.gif" width="5%" height="5%" />');
            },
            success: function (data) {
                var d = JSON.parse(data);
                $('#div_mensajes').removeClass('d-none text-center')
                if (d['msg'] == 'error') {
                    toastr.error(d['data']);
                } else {
                    toastr.success(d['data']);
                    clear_evaluacion();
                    view_tableconsultas(idconsulta);
                    $('#modal-evolucion').modal('toggle')

                }
            },
            error: function (xhr) { // if error occured
                toastr.error('Error: '.xhr.statusText + xhr.responseText);
            },
            complete: function () {
                $('#div_mensajes').addClass('d-none');
            },
            dataType: 'html'
        });
    });
    $("#btn_cancelar").click(function () {
        clear_data();
        $('.historial-tab').click()
        $('#btn_modalevol').hide();
        $('#evolucion').hide();
    });
    $(".btn_cancelarevolucion").click(function () {

        clear_evaluacion();
    });
    $("#btn_nuevo").click(function () {
        clear_data();
        $('#btn_modalevol').hide();
        $('#evolucion').hide();
    });
    $("#btn_medico").click(function () {
        view_tablemedico()
    });


    function view_tablemedico() {
        var data = $('#form_paciente').serialize();
        var pageURL = window.location.href;
        var lastURLSegment = pageURL.substr(pageURL.lastIndexOf('/') + 1);
        $.ajax({
            type: 'POST',
            url: '/view_data_medico',
            data: data,
            beforeSend: function () {
                $('#div_mensajes').removeClass('d-none');
                $('#div_mensajes').addClass('text-center');
                $('#mensajes').html('<img src="../storage/images/load.gif" width="5%" height="5%" />');
            },
            success: function (data) {
                $('#medico_div').html(data);
                $('#tbl_medicobusqueda').DataTable({
                    "paging": true,
                    "lengthChange": false,
                    "ordering": true,
                    "info": true,
                    "autoWidth": false,
                    "responsive": true,
                    "drawCallback": accionesMedico,
                });
                accionesMedico()

            },
            error: function (xhr) { // if error occured
                toastr.error('Error: '.xhr.statusText + xhr.responseText);
            },
            complete: function () {
                $('#div_mensajes').addClass('d-none');
            },
            dataType: 'html'
        });
    }

    function accionesMedico() {
        $('.btn_nombremedico').click(function () {
            $('#txt_idmedico').val( $(this).data('id'));
            $('#txt_medico').val( $(this).data('name'));
            $('#txt_medico').attr('data-id', $(this).data('id'));
            $('#modaldoctor').modal('toggle')
           // $('#txt_idpaciente').val(d['data']['idpaciente']);
        });
    }

    function accionesEvolucion() {
        $(".btn_editEvolucion").unbind().click(function () {
            var data = $(this).data('id');
            $.ajax({
                type: 'POST',
                url: '/edit_evolucion',
                data: {
                    "_token": $('meta[name="csrf-token"]').attr('content'),
                    "id": data
                },
                beforeSend: function () {
                    $('#div_mensajes').removeClass('d-none');
                    $('#div_mensajes').addClass('text-center');
                    $('#mensajes').html('<img src="../storage/images/load.gif" width="5%" height="5%" />');
                },
                success: function (d) {
                    if (d['msg'] == 'error') {
                        toastr.error(d['data']);
                    } else {
                        toastr.success(d['info']);
                        clear_data();
                        $('#txt_fecha').val(d['data']['fecha'] );
                        $('#txt_descripcioneval').val(d['data']['descripcion'] );
                        $('#imagenEvaluacion').attr('src', '../storage/images/evaluacion/'+d['data']['foto']);
                        $('#hide_idevolucion').val(d['data']['id']);
                        $('#modal-evolucion').modal('show');
                    }
                },
                error: function (xhr) {
                    toastr.error('Error: '.xhr.statusText + xhr.responseText);
                },
                complete: function () {
                    $('#div_mensajes').addClass('d-none');
                    $('#div_mensajes').html(' ');
                },
            });
        });

        $(".btn_deleteEvolucion").unbind().click(function () {
            var data = $(this).data('id');
            $.confirm({
                title: 'Eliminar Consulta!',
                content: 'Desea realizar la eliminación de la consulta ?',
                buttons: {
                    confirm: function () {
                        $.ajax({
                            type: 'POST',
                            url: '/delete_evolucion',
                            data: {
                                "_token": $('meta[name="csrf-token"]').attr('content'),
                                "id": data
                            },
                            beforeSend: function () {
                                $('#div_mensajes').removeClass('d-none');
                                $('#div_mensajes').addClass('text-center');
                                $('#mensajes').html('<img src="../storage/images/load.gif" width="5%" height="5%" />');
                            },
                            success: function (d) {
                                if (d['msg'] == 'error') {
                                    toastr.error(d['data']);
                                } else {
                                    toastr.success(d['data']);
                                    view_tableconsultas();
                                    clear_data();
                                }
                            },
                            error: function (xhr) {
                                toastr.error('Error: '.xhr.statusText + xhr.responseText);
                            },
                            complete: function () {
                                $('#div_mensajes').addClass('d-none');
                            },
                        });
                    },
                    cancel: function () {
                        $.alert('Se ha cancelado la eliminación!');
                    }
                }
            });
        });
    }


})
;

